<?

/* x10.php, Copyright (C) 2009  Bruce Pennypacker <bruce@pennypacker.org>
* http://www.pennypacker.org
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* http://www.gnu.org/licenses/gpl.html
*/


include_once("x10-config.php");

function curPageName() {
 return substr($_SERVER["SCRIPT_NAME"],strrpos($_SERVER["SCRIPT_NAME"],"/")+1);
}

function curPageURL() {
  $pageURL = 'http';
  if (isset($_SERVER["HTTPS"]) && ($_SERVER["HTTPS"] == "on")) {
   $pageURL .= "s";
  }

  $pageURL .= "://";
  if ($_SERVER["SERVER_PORT"] != "80") {
    $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
  } else {
    $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
  }

  return $pageURL;
}

function head($title="~")
{
  if($title=="~")
    $title="PHP-x10";
  /* Skip the next line (?>) then put any html to begin the page.  (Of course
   * you could also use php if you want.) */ 
?>
<html>
<head>
<title><?echo $title?></title>
</head>
<body bgcolor=FFFFFF><center>
<br>
<?
}

function foot()
{
  /* Skip the next line (?>) then put any html to close the page.  (Of course
   * you could also use php if you want.) */
?>
</body>
</html>
<?
}


$command_list=array("ON" => "On",
		    "OFF" => "Off",
		    "DIM" => "Dim",
		    "BRIGHT"=> "Brighten");

$command_group_list=array("ALL_OFF"  => "All Off",
                          "ALL_ON"  => "All On",
                          "LAMPS_ON" => "Lamps On",
                          "LAMPS_OFF" => "Lamps Off");


$url = curPageName();

  if (isset($_GET['cmd'])) {
    $req = $_GET;
  } else {
    $req = $_POST;
  }

  if (isset($req['cmd']) && isset($req['id'])) {
    $brcmd = escapeshellcmd("$cmd " . $req['id'] . " " . $req['cmd']);
  }

  # If the command is set to execute and we haven't done a redirect
  # then execute the command and force a redirect.  The redirect 
  # prevents smartphone browsers from executing the command accidentially
  # if you shut down the browser then re-launch it and cause it to reload
  # the last URL it visited.
  if (isset($brcmd) && !isset($req['redir'])) {
    system($brcmd);
    $URL = curPageURL();
    $URL .= "&redir=1";
echo <<<EOT
<html>
<head>
<meta http-equiv="refresh" content="0;$URL">
</head>
</html>
EOT;
    exit(0);
  }

  if(empty($hide_x10_header))
    head($x10_title);

  if (isset($brcmd) && isset($req['redir'])) {
    print "Executed " . $req['id'] . " " . $req['cmd'] . "<br><br>\n";
    print "<!-- $brcmd -->\n";
  }

  print "<table border=\"1\">\n";
  foreach ($x10_device as $k => $v) {
    print "<tr>\n";
    print "    <td>&nbsp;$v&nbsp;</td>\n";
    foreach ($command_list as $cmd => $name) {
      print "    <td>&nbsp;<a href=\"$url?cmd=$cmd&id=$k\">$name</a>&nbsp;</td>\n";
    }
  }
  print "</table>\n";

  if (count($x10_group)) {
    print "<br>\n";
    print "<table border=\"1\">\n";
    foreach ($x10_group as $k => $v) {
      print "<tr>\n";
      print "    <td>&nbsp;$v&nbsp;</td>\n";
      foreach ($command_group_list as $cmd => $name) {
        print "    <td>&nbsp;<a href=\"$url?cmd=$cmd&id=$k\">$name</a>&nbsp;</td>\n";
      }
    }
    print "</table>\n";
  }

if(empty($hide_x10_footer))
  foot();

?>

